# Online-Hausarbeit 2: The Bread and Butter Stuff

> Bearbeitungszeitraum: 13.07.2020 00:00 Uhr - 18.07.2020 23:59Uhr
>
> Computer Graphics 1 - Summer Semester 2020 - LMU Munich

To write your answers, please replace the corresponding `TODO:` lines.

## 1 Overview

No questions here.

## 2 Warmup

### a)

From left to right: flat, Gouraud and Phong shading, as seen by polygon edges, smooth surface and specular reflection.

## 3 See your world with Phong’s eyes

### a)

- paper ($k_a=0, k_d=1, k_s=0$)
- metal ($k_a=0$, $k_d$ small or $0$, $k_s=1$)
- lightbulb ($k_a=1$)

### b)

- glass, water, Haribo (no refraction of light described by model)

## 4 Choosing Rendering Methods

### a)

- color bleeding on the side of teapot: radiosity, because it models the light reflected from the walls
- soft shadow on the floor: ray tracing, because it correctly models shadows
- self reflection of handle: ray tracing, because it correctly models self reflections (not environment mapping!)
- darker edges of the box: radiosity, because it models the distribution of energy adequately

### b)

Shadows would have harsh edges, since each pount is either reached by the entire light or not.

## 5 Transformations

### a)

Unified representation of point, vector, and some non linear map (e.g. translation) as linear map.

### b)

No translation is needed for model transformation, or the height of scene graph is small such that transformation of all objects are easy to compute.

### c)

When scene graph hierarchy is complex, translation appears in the middle of the scene graph such that transform a leaf object along the path path easier to express using matrix multiplication.

### d)

Transforming at least two groups of objects, where one group's depth is big and the other's depth is 1. Because in this case, we can use homogeneous coordinates and regular coordinates to archive convinence and also save some memory and computations.

## 6 What’s left if nothing’s right?

### a)

Left hand from inside.

### b)

The mirror matrix implies that I wanted a left hand, but probably from outside

### c)

Normals are flipped by the matrix

### d)

Yes, backface culling is relying on the normals and hence culls front faces

### e)

No. If normals remain inside out, it will always remain a right hand.

### f)

Use a different rendering method, or switch off backface culling

## 7 The automatic camera (eliminating human error ;-)

### a)

- Reset any camera rotations to make the camera look along $-Z$ and make the horizon level (1p)
- Take the center of the Scene bonding box $(x_w = x_{\text{max}}+(x_{\text{max}}-x_{\text{min}})/2, y_w = 1.5*y_{\text{max}}-0.5*y_{\text{min}}, \dots)$ and set the camera position $x_c = x_w, y_c = y_w$ (1p)
- Make a reasonable assumption about the focal length / viewangle (e.g., $\text{fov}=45°$) (1p)
- Set the camera position such that the front face of the AABB is entirely visible, i.e. for a normal lens with $V_A=45°$ this means that the distance needs to equal the diagonal, or $z_c = z_{max} + \sqrt{(x_{max} - x_{min})^2 + (y_{max} - y_{min})^2)}$ (2p)

### b)

- Bounding sphere with position $(x_w, y_w, z_w)$ and radius $r_w$ instead of bounding box (1p)
- Compute the optical axis as $(x_w, y_w, z_w) - (x_c, y_c, z_c)$ and rotate the camera to look along it. (1p)
- Make again a reasonable assumption about FOV (e.g., 45° or distance = diagonal) (1p)
- Move the camera back along the optical axis until the distance is $2.8r_w$ (accept anything between $2$ and $3$) (1p)
- Compute the angle between the camera up vector and the the Y axis, project it onto the camera's local XY plane, and rotate it to 0 (2p)

### c)

This will fail if the camera is looking straight down or straight up (1p), because in both cases, no horizon will be in the image (alternative: the projection of the up vector to Y is 0) (1p). The concept is the Gimbal lock (1p).

## 8 A shady place

### a)

- **Vertex Shader**: apply camera transformation and show the specific part of the scene
- **Tesselation Shader**: apply displacement map for example to tree barks (or cobblestone floor)
- **Geometry Shader**: use to generate grass and all foliage (could also be used for trees)
- **Fragment Shader**: apply per pixel shading for example use normal map to add surface detail to chameleon skin

### b)

**Compute Shader**: because it can calculate physical behaviour in an efficient way on the GPU. Alternative: Use Vertex Animation in Vertex Shader or Geometry shader (not discussed in assignments).